#define UNICODE
#define _UNICODE

#include <windows.h>
#include <tlhelp32.h>
/*Based on https://stosd.wordpress.com/2017/03/29/impersonation-system/ */
BOOL isElevated() 
{
	HANDLE          hToken;
	BOOL            bResult = FALSE;
	TOKEN_ELEVATION te;
	DWORD           dwSize;
	
	if (OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, &hToken)) 
	{
		if (GetTokenInformation(hToken, TokenElevation, &te, sizeof(TOKEN_ELEVATION), &dwSize))
			bResult = te.TokenIsElevated != 0;
		
		CloseHandle(hToken);
	}
	return bResult;
}

BOOL SetPrivilege(LPWSTR szPrivilege, BOOL bEnable) 
{
	HANDLE           hToken;
	BOOL             bResult;
	LUID             luid;
	TOKEN_PRIVILEGES tp;
  
	bResult = OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &hToken);
  
	if ( ! bResult)
  		return FALSE;
  	
    bResult = LookupPrivilegeValue(NULL, szPrivilege, &luid);
    
	if (bResult) 
	{
      tp.PrivilegeCount           = 1;
      tp.Privileges[0].Luid       = luid;
      tp.Privileges[0].Attributes = (bEnable) ? SE_PRIVILEGE_ENABLED : 0;

      bResult = AdjustTokenPrivileges(hToken, FALSE, &tp, 0, NULL, NULL);
    }
    
    CloseHandle(hToken);
  
	return bResult;
}

DWORD GetSystemProcessId(wchar_t* szName) 
{
	DWORD          dwId = 0;
	HANDLE         hSnap;
	BOOL           bResult;
	PROCESSENTRY32 pe32;
	
	hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	
	if (hSnap == INVALID_HANDLE_VALUE)
		return 0;
		
	pe32.dwSize = sizeof(PROCESSENTRY32);
	
	bResult = Process32First(hSnap, &pe32);
	for ( ; dwId == 0 &&  bResult; bResult = Process32Next(hSnap, &pe32) ) 
	{
		if (lstrcmpi(pe32.szExeFile, szName) == 0)
			dwId = pe32.th32ProcessID;
	}
	
	CloseHandle(hSnap);

	return dwId;
}

BOOL ImpersonateSystem() 
{
	BOOL   bImpersonating = FALSE;
	HANDLE hToken, hProcess;
	
	DWORD  dwId = GetSystemProcessId(L"lsass.exe");
  
  	if (dwId == 0)
  		return FALSE;
  		
    if ( ! SetPrivilege(SE_DEBUG_NAME, TRUE)) 
    	return FALSE;
    	
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, dwId);
    if (hProcess != NULL) 
	{
    	if (OpenProcessToken(hProcess, TOKEN_IMPERSONATE | TOKEN_DUPLICATE | TOKEN_QUERY, &hToken)) 
		{
          bImpersonating = ImpersonateLoggedOnUser(hToken);
          CloseHandle(hToken);
        }
        CloseHandle(hProcess);
	}
	return bImpersonating;
}
