#define UNICODE
#define _UNICODE

#include <windows.h>
#include <commctrl.h>
#include "guiutil.h"
#include "events.h"
#include "evidencefile.h"
#include "find.h"
#include <stdio.h>
#include <string.h>



LRESULT WINAPI Application_OnDropFiles(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	wchar_t tmp[MAX_FILENAME];
	HDROP drop = (HDROP)wParam;
	if (DragQueryFile(drop, 0, (LPWSTR)&tmp, MAX_FILENAME) >= MAX_FILENAME)
		MessageBox(NULL, L"Il nome del file e' troppo lungo.\nSpostalo in un percorso piu' breve.", L"Nome file troppo lungo", MB_ICONEXCLAMATION | MB_OK );
		
	SetWindowText(simpleHasher.txtFilePath, tmp);
	return 0;
}

LRESULT WINAPI Application_OnTimer(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
		
	if (simpleHasher.timer)
	{
	
		KillTimer(hWnd, simpleHasher.timer);
		/* Enum volumes */
		EnumVolumes(&simpleHasher);
	}
	return 0;
}

LRESULT WINAPI Application_OnMinMax(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	MINMAXINFO* info = (MINMAXINFO*)lParam;
	POINT minLen = { 500, 500 };
	info->ptMinTrackSize = minLen;
		
	return 0;	
}

LRESULT WINAPI Application_OnResize(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	static const int HMARGIN = 8, VMARGIN = 12, LBL_HEIGHT = 30, BTN_WIDTH = 80, BTN_HEIGHT = 40;
	RECT mainWin;
	GetClientRect(simpleHasher.wndMain, &mainWin);
	
	const int W = mainWin.right - mainWin.left, H = mainWin.bottom - mainWin.top; 
	
	SetWindowPos(simpleHasher.lblSelectDrive, HWND_NOTOPMOST, HMARGIN, VMARGIN, W - HMARGIN * 2, LBL_HEIGHT, SWP_NOZORDER);
	
	const int BELOW_FIRST_LABEL = VMARGIN * 2 + LBL_HEIGHT;
	
	SetWindowPos(simpleHasher.btnStart, HWND_NOTOPMOST, W - HMARGIN * 3 - BTN_WIDTH, H - BTN_HEIGHT - VMARGIN * 3, BTN_WIDTH, BTN_HEIGHT, SWP_NOZORDER);
	SetWindowPos(simpleHasher.btnPause, HWND_NOTOPMOST, HMARGIN, H - BTN_HEIGHT - VMARGIN * 3, BTN_WIDTH * 2, BTN_HEIGHT, SWP_NOZORDER);
	
	const int ABOVE_START = H - BTN_HEIGHT - VMARGIN * 3;
	
	SetWindowPos(simpleHasher.chkShowPercent, HWND_NOTOPMOST, HMARGIN, H - BTN_HEIGHT - VMARGIN * 3 - LBL_HEIGHT - VMARGIN, W - HMARGIN * 2, LBL_HEIGHT, SWP_NOZORDER);
	SetWindowPos(simpleHasher.chkEncrypted, HWND_NOTOPMOST, HMARGIN, H - BTN_HEIGHT - VMARGIN * 3 - LBL_HEIGHT - VMARGIN - LBL_HEIGHT - VMARGIN, W - HMARGIN * 2, LBL_HEIGHT, SWP_NOZORDER);

	const int ABOVE_THE_CHECKBOXES = H - BTN_HEIGHT - VMARGIN * 3 - LBL_HEIGHT - VMARGIN - LBL_HEIGHT - VMARGIN;

	SetWindowPos(simpleHasher.txtFilePath, HWND_NOTOPMOST, HMARGIN, ABOVE_THE_CHECKBOXES - BTN_HEIGHT - VMARGIN * 2 , W - HMARGIN * 3 - BTN_WIDTH, LBL_HEIGHT, SWP_NOZORDER);
	SetWindowPos(simpleHasher.btnBrowse, HWND_NOTOPMOST, W - HMARGIN - BTN_WIDTH, ABOVE_THE_CHECKBOXES - BTN_HEIGHT - VMARGIN * 2 - (BTN_HEIGHT - LBL_HEIGHT) / 2, BTN_WIDTH, BTN_HEIGHT, SWP_NOZORDER);

	const int ABOVE_BROWSE = ABOVE_THE_CHECKBOXES - BTN_HEIGHT - VMARGIN * 2 - (BTN_HEIGHT - LBL_HEIGHT) / 2 - VMARGIN;
	
	SetWindowPos(simpleHasher.lblSelectFile, HWND_NOTOPMOST, HMARGIN, ABOVE_BROWSE - LBL_HEIGHT  - VMARGIN, W - HMARGIN * 2, LBL_HEIGHT , SWP_NOZORDER);

	const int ABOVE_LBL_BROWSE =  ABOVE_BROWSE - LBL_HEIGHT - VMARGIN * 2;
	
	SetWindowPos(simpleHasher.tvwDrives, HWND_NOTOPMOST, HMARGIN, BELOW_FIRST_LABEL, W - HMARGIN * 2,  ABOVE_LBL_BROWSE - BELOW_FIRST_LABEL , SWP_NOZORDER);
	
	SetWindowPos(simpleHasher.txtLog, HWND_TOP, 0, 0, W, ABOVE_START - LBL_HEIGHT*2 - VMARGIN*2, 0);
	SetWindowPos(simpleHasher.lblProgress, HWND_TOP, HMARGIN, ABOVE_START - LBL_HEIGHT*2 - VMARGIN,  W - HMARGIN * 2, LBL_HEIGHT*2, SWP_NOZORDER);
	
	return 0;
}

LRESULT WINAPI Application_OnShow(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	if (wParam)
	{
		PostMessage(hWnd, WM_SIZE, 0, 0);
		
		/* Check the progress bar setting */
		SendMessage(simpleHasher.chkShowPercent, BM_SETCHECK, BST_CHECKED, 0);
		
		simpleHasher.timer = 1;
		SetTimer(simpleHasher.wndMain, 1, 100, NULL);
	}
	return DefWindowProc(hWnd, Msg, wParam, lParam);
}

LRESULT WINAPI Application_OnClose(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	if (! simpleHasher.started || 
		(simpleHasher.started && MessageBox(NULL, L"Uscendo interromperai la ricerca.\r\nSei sicuro?", L"Interrompere?", MB_ICONQUESTION | MB_YESNO) == IDYES) )
		PostMessage(hWnd, WM_QUIT, 0, 0);

	return 0;
}

LRESULT WINAPI Application_OnClick(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	/* Browse */
	if ( (HWND)lParam == simpleHasher.btnBrowse)
	{
		wchar_t filename[MAX_FILENAME]= {0};
		
		OPENFILENAME open;
		open.lStructSize = sizeof(OPENFILENAME);
		open.hwndOwner = simpleHasher.wndMain;
		open.hInstance = GetModuleHandle(NULL);
		open.lpstrFilter = L"File di testo (*.txt)\0*.txt\0Tutti i file\0*.*\0\0";
		open.lpstrCustomFilter = NULL;
		open.nMaxCustFilter = 0;
		open.nFilterIndex = 1;
		open.lpstrFile = filename;
		open.nMaxFile = MAX_FILENAME;
		open.lpstrFileTitle = NULL;
		open.nMaxFileTitle = 0;
		open.lpstrInitialDir = NULL;
		open.lpstrTitle =  L"Apri file delle evidenze";
		open.Flags = OFN_ENABLESIZING | OFN_FILEMUSTEXIST | OFN_FORCESHOWHIDDEN |  OFN_LONGNAMES | OFN_PATHMUSTEXIST | OFN_SHAREAWARE;
		open.nFileOffset = 0;
		open.nFileExtension = 0;
		open.lpstrDefExt = L".txt";
		open.lCustData =  0;
		open.lpfnHook = NULL;
		open.lpTemplateName = NULL;
		open.pvReserved = NULL;
		open.dwReserved = 0;
		open.FlagsEx = 0;
	
		if (GetOpenFileName(&open))
		{
			SetWindowText(simpleHasher.txtFilePath,filename);
		}
		else
		{
			if (CommDlgExtendedError() == FNERR_BUFFERTOOSMALL)
				MessageBox(NULL, L"Il nome del file scelto e' troppo lungo.\nSpostalo in un percorso piu' breve.", L"Nome file troppo lungo", MB_ICONEXCLAMATION | MB_OK);
		}
	}
	
	/* Start */
	if ( (HWND)lParam == simpleHasher.btnStart)
	{
		if (simpleHasher.started)
		{
			if (MessageBox(NULL, L"Sei sicuro di interrompere la ricerca?", L"Conferma interruzione", MB_ICONQUESTION | MB_YESNO) == IDYES)
			{
				EnableWindow(simpleHasher.btnStart, FALSE);
				EnableWindow(simpleHasher.btnPause, FALSE);
				
				simpleHasher.running = TRUE;
				simpleHasher.stopping = TRUE;
				
				PostLog(L"Interrompo la ricerca...");
			}
		}
		else 
		{
			/* Done */
			if (simpleHasher.done)
			{
				ShowLog(FALSE);
				simpleHasher.done = FALSE;
				return 0;
			}
			
			simpleHasher.done = FALSE;
			simpleHasher.count = 0;
			HTREEITEM node = TreeView_GetRoot(simpleHasher.tvwDrives);
			for (; node; node = TreeView_GetNextSibling(simpleHasher.tvwDrives, node))
			{
				if (TreeView_GetCheckState(simpleHasher.tvwDrives, node))
					simpleHasher.count++;
			}
			
			if (simpleHasher.count == 0)
			{
				MessageBox(NULL, L"Selezionare almeno un disco da analizzare.", L"Nessun disco selezionato", MB_ICONEXCLAMATION | MB_OK);
				return 0;
			}
			
			if ( ReadEvidences(&simpleHasher, &simpleHasher.hashList))
				return 0;
			
			if (EncryptedEvidences() && simpleHasher.hashList->hashTypes != MD5)
			{
				FreeMem(simpleHasher.hashList);
				MessageBox(NULL, L"Il file di evidenze selezionato non contiene evidenze cifrate.", L"Errore file delle evidenze", MB_ICONEXCLAMATION | MB_OK);
				return 0;
			}
			
			/* Sort the hashes */
			struct HASHLIST* hl = simpleHasher.hashList;
			qsort(hl->hashes, hl->nHash, sizeof(struct HASH), &cmpHash);
			
			ShowLog(TRUE);
			ShowWindow(simpleHasher.btnPause,  SW_SHOW);
			SetWindowText(simpleHasher.btnStart, L"Ferma");
			
			simpleHasher.stopping = FALSE;
			simpleHasher.started = simpleHasher.running =  TRUE;
			
			FindEvidences(&simpleHasher);
		}
		
	}
	
	/* Pause / Resume */
	if ( (HWND)lParam == simpleHasher.btnPause)
	{
		if ( ! simpleHasher.started )
			return 0;
			
		SetWindowText(simpleHasher.btnPause, simpleHasher.running ? L"Riprendi" : L"Sospendi");
		AddToLog(simpleHasher.running ? L"*** RICERCA SOSPESA *** " : L"*** RICERCA RIPRESA ***");
		simpleHasher.running = !simpleHasher.running;
	}
	
	return 0;
}

LRESULT WINAPI Application_OnStopped(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	SetWindowText(simpleHasher.btnStart, L"Inizia");
	SetWindowText(simpleHasher.btnPause, L"Sospendi");
	ShowLog(FALSE);
	ShowWindow(simpleHasher.btnPause,  SW_HIDE);
	
	EnableWindow(simpleHasher.btnStart, TRUE);
	EnableWindow(simpleHasher.btnPause, TRUE);
	
	simpleHasher.running = simpleHasher.stopping = simpleHasher.started = simpleHasher.done = FALSE;
	
	return 0;
}

LRESULT WINAPI Application_OnDoFind(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	AddToLog(L"*** INIZIO RICERCA ***");
	
	if (simpleHasher.totalSize != 0)
	{
		wchar_t tmp[50], tmp2[200];
		SizeToStr(tmp, 50, simpleHasher.totalSize);
		swprintf(tmp2, 200, L"Dimensione totale da controllare: %s", tmp);
		AddToLog(tmp2);
	}
	
	ResetQueue(simpleHasher.fileQueue);
	
	/* Count the drives */
	simpleHasher.count = 0;
	HTREEITEM node = TreeView_GetRoot(simpleHasher.tvwDrives);
	for (; node; node = TreeView_GetNextSibling(simpleHasher.tvwDrives, node))
	{
		if (TreeView_GetCheckState(simpleHasher.tvwDrives, node))
			simpleHasher.count++;
	}
	
	DoFindEvidences(&simpleHasher);
	
	return 0;
}

LRESULT WINAPI Application_OnDone(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	(void)hWnd; (void)Msg; (void)wParam; (void)lParam;
	
	wchar_t timeSpent[300], tmp[50];
	
	int secs = (simpleHasher.startTime / 1000) % 60;
	int mins = (simpleHasher.startTime / 1000 / 60) % 60;
	int hours = (simpleHasher.startTime / 1000 / 60 / 60) % 24;
	int days = (simpleHasher.startTime / 1000 / 60 / 60 / 24);
	
	wcscpy(timeSpent, L"*** RICERCA TERMINATA ***\r\nTempo impiegato: ");
	
	if (days > 0)
	{
		swprintf(tmp, 50, L"%d giorni ", days);
		wcscat(timeSpent, tmp);
	}
	
	if (hours > 0)
	{
		swprintf(tmp, 50, L"%d ore ", hours);
		wcscat(timeSpent, tmp);
	}
	
	if (mins > 0)
	{
		swprintf(tmp, 50, L"%d min ", mins);
		wcscat(timeSpent, tmp);
	}
	
	if (secs > 0 || (mins == 0 && hours == 0 && days == 0))
	{
		swprintf(tmp, 50, L"%d sec ", secs);
		wcscat(timeSpent, tmp);
	}	

	CloseHandle(simpleHasher.hLogFile);
	ShowWindow(simpleHasher.btnPause, SW_HIDE);
	SetWindowText(simpleHasher.btnStart, L"Chiudi");
	SetWindowText(simpleHasher.lblProgress, timeSpent);
	simpleHasher.started = simpleHasher.running = simpleHasher.stopping = FALSE;
	simpleHasher.done = TRUE;
	FreeMem(simpleHasher.hashList);
	
	return 0;
}
