#ifndef _GUIUTIL
#define _GUIUTIL

#include "simplehashr.h"
#include <windows.h>
#include "evidencefile.h"

#define MAKE_DWORDLONG(high, low) (((DWORDLONG)high) << 32 | low)
#define DWORDLONG_LOW(d) ((DWORD)d & 0xffffffff)
#define DWORDLONG_HIGH(d) ((DWORD) ((d >> 32) & 0xffffffff))

int cmpHash(const void *a, const void *b);
void HashToString(wchar_t* dest, unsigned char* hash, int len);
void SizeToStr(wchar_t* str, DWORD len, DWORDLONG size);
BOOL CheckHeap();

void ShowLog(BOOL show);
BOOL EncryptedEvidences();
BOOL ShowPercent();
void AddToLog(wchar_t* str);
void PostLog(wchar_t* str);
void PostStatus(wchar_t* str);
void ShowLastError(wchar_t* title, wchar_t* message);
int EnumVolumes(struct SimpleHasher* simpleHasher);
void ToPerc(wchar_t* str, DWORD size, DWORDLONG* all, DWORDLONG* cur, int skipped);
void PostError(wchar_t* str);
HANDLE OpenLogFile();
void LastErrorString(wchar_t* errorString, DWORD size);

void* AllocString(SIZE_T size);
void* AllocMem(SIZE_T size);
void FreeMem(void* base);

#endif
