#include "monitors.h"

/* Get the position and size (in virtual screen coords) of the primary monitor */
RECT GetPrimaryMonitor()
{
	RECT primaryRect = {0, 0, -1, -1}, fallbackRect =  { .left = 0, .top = 0, .right = GetSystemMetrics(SM_CXSCREEN), .bottom = GetSystemMetrics(SM_CYSCREEN)};
	EnumDisplayMonitors(NULL, NULL, &FindPrimary, (LPARAM)&primaryRect);
	
	/* Fallback to the usual API */
	if (primaryRect.right == -1)
		return fallbackRect;
		
	return primaryRect;
}
/* Callback for enumerating the monitors */
BOOL WINAPI FindPrimary(HMONITOR hMonitor,  HDC hDC,  LPRECT monitor, LPARAM lParam)
{
	(void)hMonitor; (void)hDC; (void)monitor; (void)lParam;
	
	MONITORINFO info;
	info.cbSize = sizeof(info);
	
	/* Get the primary screen work rect */
	if (GetMonitorInfo(hMonitor, &info) && info.dwFlags & MONITORINFOF_PRIMARY)
	{
		RECT* pRect = (RECT*)lParam;
		*pRect = info.rcWork;
		return FALSE; 
	}
	
	return TRUE;
}
