#ifndef _SIMPLEHASHR
#define _SIMPLEHASHR

#define _UNICODE
#define UNICODE

/* Must be before queue.h */
#define MAX_FILENAME 4096

#include <windows.h>
#include "queue.h"

struct SimpleHasher
{
	HWND wndMain;
	HWND lblSelectDrive;
	HWND tvwDrives;
	HWND lblSelectFile;
	HWND txtFilePath;
	HWND btnBrowse;
	HWND chkEncrypted;
	HWND chkShowPercent;
	HWND btnStart;
	HWND btnPause;
	UINT timer;
	HWND txtLog;
	volatile BOOL running;
	volatile BOOL started;
	volatile BOOL stopping;
	HWND lblProgress;
	struct HASHLIST* hashList;
	CRITICAL_SECTION critical_section;
	DWORDLONG totalSize; 
	DWORDLONG curSize; 
	volatile int count;
	struct FQUEUE* fileQueue;
	volatile int nHashingThreads;
	HANDLE eventDone;
	HANDLE hLogFile;
	volatile int skippedFiles;
	BOOL encryptedEvidence;
	BOOL done;
	DWORD startTime;
};

struct SimpleHasher simpleHasher;

/* Custom message for background-foreground communication*/
#define UM_FIND		(WM_USER+ 101)
#define UM_STOPPED	(WM_USER+ 102)
#define UM_DONE		(WM_USER+ 103)

/* 
	How much of a file to map in memory at once. 
	NOTE: This is not about memory consuption, mmapping files don't "consume" memory, this is about how much address space we have.
	For example, we cannot map a 4GiB file entirely in a 32-bit program, there are simple not enough addresses if we take the Windows kernel and other
	components into account (not sure if PAE would help, it's not necessarily enabled anywhere, anyway).
*/

#ifndef _WIN64
	/* 1 GiB */
	#define MAP_MAX_LOW  0x40000000
	#define MAP_MAX_HIGH 0x00000000
#else
	/* 256 GiB */
	#define MAP_MAX_LOW  0x00000000
	#define MAP_MAX_HIGH 0x00000040
#endif

#define MAP_MAX ((DWORDLONG)MAP_MAX_HIGH << 32 | MAP_MAX_LOW)

#endif
